// Description: establishes a view point for the CAVE library rendering
//
//<b>notes:</b>
//<ul>
//<li> derived nodes inherit all messages from their base classes
//<li> creates a tracked transform from CAVE sensor 0
//<li> added automatically to scene at startup unless the --noview option is used
//</ul>
//
// Category: Foundation
// Author: Dave Pape
// Revision: 11/01/01
//
#include <pfcave.h>
#include "ygCAVEViewer.h"

extern "C" ygNode* construct_ygCAVEViewer(const char* name,bool master) { return new ygCAVEViewer(name,master); }


ygCAVEViewer::ygCAVEViewer(const char* name,bool master) : ygTransform(name,master)
	{
	setClassName("ygCAVEViewer");
	dontBroadcastNetKey("m");
	}


void ygCAVEViewer::app(void)
	{
	pfVec3 pos, ori;
	//get CAVE head position
	CAVEGetPosition(CAVE_HEAD_NAV, pos.vec);
	//get CAVE head orientation
	CAVEGetOrientation(CAVE_HEAD_NAV, ori.vec);
	//set the position and orientation of the transform
	setPosition(pos);
	setOrientation(ori);
	ygTransform::app();
	}
