/*
 * Ygdrasil Version 0.1.7
 */
#ifndef _ygSound_h_
#define _ygSound_h_

#include "ygSpace.h"


class ygSound : public ygSpace
	{
	public:
	 ygSound(const char*,bool master=true);
	 virtual ~ygSound(void);
	 virtual void reset(void);
	 virtual void message(const ygMessage&);
	 virtual void app(void);
		 void play(void);
		 void stop(bool sendStopCommand=true);
		 void setFile(const ygString&);
		 void setAmplitude(float);
		 void setFalloffDistance(float);
		 void setLoop(bool);
		 void setCurAmplitude(float);
		 bool isPlaying(void);
	 virtual float computeAmplitude(void);
	 static void initServer(void);
	 static void updateServer(void);
	 static void closeServer(void);
	 static class bergenServer * server(void);
	protected:
	 void acceptNetKey(const ygString& key);
	private:
	 struct _ygSoundPrivateData * p_;
		 void heartbeat(void);
	 static struct _ygSoundGlobalData * global_;
	 static  void addSound(ygSound*);
	 static  void removeSound(ygSound*);
	};

extern "C" ygNode* construct_ygSound(const char*,bool);

#endif
